/*  Apply b.c. defined in u on matrix and right hand side	*/
/*  via penalty method. 					*/
/*  The routine ApplyDirichletBC from applybc.cpp not well suited for multigrid ==> ApplyDirichletBC1	*/

int AdrCRS(const int row, const int col, const int id[], const int ik[], const int nnode)
{
  int row_l, col_l, id1, id2, ij, k;

  if (row<0 || nnode<=row || col<0 || nnode<=col)   return -1;

  /* only upper half stored */
  if ( row <= col ) { row_l = row; col_l = col; }
  else 		    { row_l = col; col_l = row; }
  
  id1 = (row_l==0) ? 0 : id[row_l-1]+1;
  id2 = id[row_l]; 

  ij  = -1;  
  for (k=id1; k<=id2; k++)
    if (col_l==ik[k])  ij = k;
  
  return ij;
}

/*  Apply b.c. defined in u on matrix and right hand side	*/
/*  via deleting rows and columns in matrix. 			*/

void ApplyDirichletBC1(const int nx, const int ny, const int neigh[], 
	const double u[], double sk[], const int id[], const int ik[] , double f[])
{
//   double penalty=1e6;
  int    i,j,k,start[4],end[4],step[4],dx,dy,tl,tr,bl,br,ij,nnode;
 
  nnode = (ny+1)*(nx+1);
  dx = 1;
  dy = nx+1;
  bl  = 0;
  br  = nx;
  tl  = ny*(nx+1);
  tr  = (ny+1)*(nx+1)-1; 
  start[0] = bl;  end[0] = br;  step[0] = dx;
  start[1] = br;  end[1] = tr;  step[1] = dy;
  start[2] = tl;  end[2] = tr;  step[2] = dx;
  start[3] = bl;  end[3] = tl;  step[3] = dy;
  
  for (j=0; j<4; j++)
  {
    if (neigh[j]<0)
    {
      for (i=start[j]; i<=end[j]; i += step[j])
      {
	ij = AdrCRS(i,i,id,ik,nnode);
	sk[ij] = 1.0;  f[i] = u[i];

	k  = i-nx-2;	ij = AdrCRS(i,k,id,ik,nnode);  
	if (ij>=0)  { f[k] -= sk[ij]*u[i] ; sk[ij] = 0.0; }
	k  = i-nx-1;	ij = AdrCRS(i,k,id,ik,nnode);  
	if (ij>=0)  { f[k] -= sk[ij]*u[i] ; sk[ij] = 0.0; }
	k  = i-1;	ij = AdrCRS(i,k,id,ik,nnode);  
	if (ij>=0)  { f[k] -= sk[ij]*u[i] ; sk[ij] = 0.0; }
	k  = i+1;	ij = AdrCRS(i,k,id,ik,nnode);  
	if (ij>=0)  { f[k] -= sk[ij]*u[i] ; sk[ij] = 0.0; }
	k  = i+nx+1;	ij = AdrCRS(i,k,id,ik,nnode);  
	if (ij>=0)  { f[k] -= sk[ij]*u[i] ; sk[ij] = 0.0; }
	k  = i+nx+2;	ij = AdrCRS(i,k,id,ik,nnode);  
	if (ij>=0)  { f[k] -= sk[ij]*u[i] ; sk[ij] = 0.0; }
      }
    }
  }
 return;
}























