
#include <malloc.h>
#include "header.h"

void JacobiSmooth(const int nx, const int ny,
		  const double sk[], const int id[], const int ik[],
		  const double f[], double u[], const double dd[],
		  double aux[], const int maxiter )
{
  const double omega = 0.8;
  const int nnode = (nx+1)*(ny+1);
  double *r = aux;                            /* ( and  w = r ! )   */

  /* Iteration sweeps */                      /* no inner product ! */
  int iter  = 0;
  while ( maxiter>iter)
  {
    iter++;
    
    vdcopy(nnode, r, 1, f, 1);			/*                 */
    CrsMult(0, nnode-1, r, u, id, ik, sk, -1.0);/*  r := f - K*u   */

    vddiv(nnode, r, 1, r, 1, dd, 1);		/*  w := D^{-1}*r  */ 
    
    vdaxpy(nnode, u, u, omega, r );		/*  u := u + om*w  */  
    
/*    if (myid==0)  printf("Iteration %u : %g\n",iter);     */
  }
  
  return;
}
